
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>src.vendor package &#8212; BRMS Engine 1.0 documentation</title>
    
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head>
  <body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="src-vendor-package">
<h1>src.vendor package<a class="headerlink" href="#src-vendor-package" title="Permalink to this headline">¶</a></h1>
<div class="section" id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="module-src.vendor.datastorage">
<span id="src-vendor-datastorage-module"></span><h2>src.vendor.datastorage module<a class="headerlink" href="#module-src.vendor.datastorage" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.vendor.datastorage.DataStorage">
<em class="property">class </em><code class="descclassname">src.vendor.datastorage.</code><code class="descname">DataStorage</code><a class="reference internal" href="_modules/src/vendor/datastorage.html#DataStorage"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.datastorage.DataStorage" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal"><span class="pre">object</span></code></p>
<p>DataStorage class implements AWS S3.</p>
<p>This class implements boto3 API to interact with S3 service. Currently it supports the following methods:
upload_file(): copy an input dataframe into a csv at unique S3 temp location,
use default s3 client method to copy to desired path</p>
<p>download_file(): copy csv from remote path to unique S3 path with temp filename,
return csv as dataframe to user and delete temp file.</p>
<p>copy_file(): use boto3 resource methods to loop and filter out src_path objects and copy one by one</p>
<p>exists(): use try catch block to validate whether given key exists in the bucket</p>
<p>list_files(): use it to get list of files at a given prefix of location</p>
<dl class="docutils">
<dt>Attributes:</dt>
<dd><table class="first last docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">param:</th><td class="field-body">src_path: source path</td>
</tr>
<tr class="field-even field"><th class="field-name">param:</th><td class="field-body">dest_path: destination_path</td>
</tr>
<tr class="field-odd field"><th class="field-name">param:</th><td class="field-body"></td>
</tr>
</tbody>
</table>
</dd>
</dl>
<dl class="attribute">
<dt id="src.vendor.datastorage.DataStorage.bucket">
<code class="descname">bucket</code><em class="property"> = ‘salesiq-mapserver’</em><a class="headerlink" href="#src.vendor.datastorage.DataStorage.bucket" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.datastorage.DataStorage.copy_file">
<em class="property">static </em><code class="descname">copy_file</code><span class="sig-paren">(</span><em>src_path</em>, <em>dest_path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/datastorage.html#DataStorage.copy_file"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.datastorage.DataStorage.copy_file" title="Permalink to this definition">¶</a></dt>
<dd><p>Copies all the files from src_path to dest_path</p>
</dd></dl>

<dl class="attribute">
<dt id="src.vendor.datastorage.DataStorage.directory">
<code class="descname">directory</code><em class="property"> = ‘.//tmp//’</em><a class="headerlink" href="#src.vendor.datastorage.DataStorage.directory" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.datastorage.DataStorage.download_file">
<em class="property">static </em><code class="descname">download_file</code><span class="sig-paren">(</span><em>remote_path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/datastorage.html#DataStorage.download_file"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.datastorage.DataStorage.download_file" title="Permalink to this definition">¶</a></dt>
<dd><p>downloads file from s3 and returns the data frame</p>
</dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.datastorage.DataStorage.exists">
<em class="property">static </em><code class="descname">exists</code><span class="sig-paren">(</span><em>key</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/datastorage.html#DataStorage.exists"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.datastorage.DataStorage.exists" title="Permalink to this definition">¶</a></dt>
<dd><p>Validates presence of key for a given S3 bucket.</p>
</dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.datastorage.DataStorage.list_files">
<em class="property">static </em><code class="descname">list_files</code><span class="sig-paren">(</span><em>prefix: str</em><span class="sig-paren">)</span> &#x2192; list<a class="reference internal" href="_modules/src/vendor/datastorage.html#DataStorage.list_files"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.datastorage.DataStorage.list_files" title="Permalink to this definition">¶</a></dt>
<dd><p>returns all ‘folders’ and file names in s3 under the prefix folder</p>
</dd></dl>

<dl class="attribute">
<dt id="src.vendor.datastorage.DataStorage.s3_client">
<code class="descname">s3_client</code><em class="property"> = &lt;botocore.client.S3 object&gt;</em><a class="headerlink" href="#src.vendor.datastorage.DataStorage.s3_client" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="src.vendor.datastorage.DataStorage.s3_resource">
<code class="descname">s3_resource</code><em class="property"> = s3.ServiceResource()</em><a class="headerlink" href="#src.vendor.datastorage.DataStorage.s3_resource" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.datastorage.DataStorage.upload_file">
<em class="property">static </em><code class="descname">upload_file</code><span class="sig-paren">(</span><em>data_obj</em>, <em>remote_path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/datastorage.html#DataStorage.upload_file"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.datastorage.DataStorage.upload_file" title="Permalink to this definition">¶</a></dt>
<dd><p>For a given filename and path, upload from ./tmp directory to AWS incoming bucket.</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.vendor.redshift">
<span id="src-vendor-redshift-module"></span><h2>src.vendor.redshift module<a class="headerlink" href="#module-src.vendor.redshift" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.vendor.redshift.Redshift">
<em class="property">class </em><code class="descclassname">src.vendor.redshift.</code><code class="descname">Redshift</code><a class="reference internal" href="_modules/src/vendor/redshift.html#Redshift"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.redshift.Redshift" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal"><span class="pre">object</span></code></p>
<p>Redshift class to connect and execute queries on Redshift cluster.
Credentials are taken from config file and connected to cluster whenever object is called.
No explicit operator required for commiting DML statements as autocommit is True.</p>
<dl class="docutils">
<dt>Methods</dt>
<dd><p class="first">execute_query(): Return query execution status and log if any error occurs.
:param query: A string
:return : A bool</p>
<p>return_output(): Execute query and return output if no error occurs.</p>
<p>drop_table(): Execute drop table query.
:param table_name: Name of table
:param schema_name: Name of table schema</p>
<p class="last">unload_table(): Output Table to S3 a single file.
:param table_name: Name of table
:param schema_name: Name of table schema
:param s3_location: S3 Bucket location for file output</p>
</dd>
</dl>
<dl class="attribute">
<dt id="src.vendor.redshift.Redshift.conn">
<code class="descname">conn</code><em class="property"> = &lt;connection object at 0x06686C10; dsn: ‘user=salesiq password=xxx dbname=salesiq host=salesiq-782.coya9jnvir3f.us-west-2.redshift.amazonaws.com port=5439’, closed: 0&gt;</em><a class="headerlink" href="#src.vendor.redshift.Redshift.conn" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="src.vendor.redshift.Redshift.connection_str">
<code class="descname">connection_str</code><em class="property"> = “dbname=’salesiq’ host=’salesiq-782.coya9jnvir3f.us-west-2.redshift.amazonaws.com’ port=‘5439’ user=’salesiq’ password=’Axtria01’”</em><a class="headerlink" href="#src.vendor.redshift.Redshift.connection_str" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.redshift.Redshift.drop_table">
<em class="property">static </em><code class="descname">drop_table</code><span class="sig-paren">(</span><em>table_name: str</em>, <em>schema_name: str</em><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/vendor/redshift.html#Redshift.drop_table"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.redshift.Redshift.drop_table" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.redshift.Redshift.execute_query">
<em class="property">static </em><code class="descname">execute_query</code><span class="sig-paren">(</span><em>query: str</em><span class="sig-paren">)</span> &#x2192; bool<a class="reference internal" href="_modules/src/vendor/redshift.html#Redshift.execute_query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.redshift.Redshift.execute_query" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.redshift.Redshift.return_output">
<em class="property">static </em><code class="descname">return_output</code><span class="sig-paren">(</span><em>query: str</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/redshift.html#Redshift.return_output"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.redshift.Redshift.return_output" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.redshift.Redshift.unload_table">
<em class="property">static </em><code class="descname">unload_table</code><span class="sig-paren">(</span><em>table_name</em>, <em>schema_name: str</em>, <em>s3_location</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/redshift.html#Redshift.unload_table"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.redshift.Redshift.unload_table" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.vendor.salesforce">
<span id="src-vendor-salesforce-module"></span><h2>src.vendor.salesforce module<a class="headerlink" href="#module-src.vendor.salesforce" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="src.vendor.salesforce.SalesForce">
<em class="property">class </em><code class="descclassname">src.vendor.salesforce.</code><code class="descname">SalesForce</code><a class="reference internal" href="_modules/src/vendor/salesforce.html#SalesForce"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.salesforce.SalesForce" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal"><span class="pre">object</span></code></p>
<p>Salesforce class to connect and interact with salesforce platform.
Credentials are taken from config file and logined using security token method whenever object is called.
We can write queries in Salesforce Object Query Language(SOQL).</p>
<blockquote>
<div><dl class="docutils">
<dt>Methods</dt>
<dd><p class="first">query(): Return query execution records/result and log the query .
:param query_string: A string
:return : A list</p>
<p class="last">query_all(): In order to retrieve large number of records into a dataframe using a single call.
:param query_string: A string
:return : A dataframe</p>
</dd>
</dl>
</div></blockquote>
<dl class="attribute">
<dt id="src.vendor.salesforce.SalesForce.business_rule">
<code class="descname">business_rule</code><em class="property"> = &lt;simple_salesforce.api.SFType object&gt;</em><a class="headerlink" href="#src.vendor.salesforce.SalesForce.business_rule" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.salesforce.SalesForce.query">
<em class="property">static </em><code class="descname">query</code><span class="sig-paren">(</span><em>query_string</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/src/vendor/salesforce.html#SalesForce.query"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.salesforce.SalesForce.query" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="staticmethod">
<dt id="src.vendor.salesforce.SalesForce.query_all">
<em class="property">static </em><code class="descname">query_all</code><span class="sig-paren">(</span><em>query_string: str</em><span class="sig-paren">)</span> &#x2192; pandas.core.frame.DataFrame<a class="reference internal" href="_modules/src/vendor/salesforce.html#SalesForce.query_all"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#src.vendor.salesforce.SalesForce.query_all" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="src.vendor.salesforce.SalesForce.scenario">
<code class="descname">scenario</code><em class="property"> = &lt;simple_salesforce.api.SFType object&gt;</em><a class="headerlink" href="#src.vendor.salesforce.SalesForce.scenario" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="src.vendor.salesforce.SalesForce.scenario_rule_instance">
<code class="descname">scenario_rule_instance</code><em class="property"> = &lt;simple_salesforce.api.SFType object&gt;</em><a class="headerlink" href="#src.vendor.salesforce.SalesForce.scenario_rule_instance" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="src.vendor.salesforce.SalesForce.sf">
<code class="descname">sf</code><em class="property"> = &lt;simple_salesforce.api.Salesforce object&gt;</em><a class="headerlink" href="#src.vendor.salesforce.SalesForce.sf" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-src.vendor">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-src.vendor" title="Permalink to this headline">¶</a></h2>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">src.vendor package</a><ul>
<li><a class="reference internal" href="#submodules">Submodules</a></li>
<li><a class="reference internal" href="#module-src.vendor.datastorage">src.vendor.datastorage module</a></li>
<li><a class="reference internal" href="#module-src.vendor.redshift">src.vendor.redshift module</a></li>
<li><a class="reference internal" href="#module-src.vendor.salesforce">src.vendor.salesforce module</a></li>
<li><a class="reference internal" href="#module-src.vendor">Module contents</a></li>
</ul>
</li>
</ul>
<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
  </ul></li>
</ul>
</div>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/src.vendor.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="search.html" method="get">
      <div><input type="text" name="q" /></div>
      <div><input type="submit" value="Go" /></div>
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2018, SalesIQ-BRM-DM.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.6.2</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
      |
      <a href="_sources/src.vendor.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>